SUBROUTINE ConvXyzMixed(nb,ncart,x,y,z,ind_zmat,val_zmat)

  IMPLICIT NONE

  INTEGER, PARAMETER :: KINT=KIND(1)
  INTEGER, PARAMETER :: KREAL=KIND(1.0D0)



  INTEGER(KINT), INTENT(IN) :: nb,ncart,ind_zmat(nb,5)
  REAL(KREAL), INTENT(IN) :: x(Nb),y(nb),z(nb)
  REAL(KREAL), INTENT(INOUT) :: val_zmat(nb,3)

  integer(KINT) :: n1,n2,n3,n4
  integer(KINT) :: i,i1,i2,ibeg

  real(KREAL) ::  vx1,vy1,vz1,norm1
  real(KREAL) ::  vx2,vy2,vz2,norm2
  real(KREAL) ::  vx3,vy3,vz3,norm3
  real(KREAL) ::  vx4,vy4,vz4,norm4
  real(KREAL) ::  vx5,vy5,vz5,norm5
  real(KREAL) ::  val,val_d

  INTERFACE
     function valid(string) result (isValid)
       CHARACTER(*), intent(in) :: string
       logical                  :: isValid
     END function VALID

     FUNCTION angle(v1x,v1y,v1z,norm1,v2x,v2y,v2z,norm2)
        use Path_module, only :  Pi,KINT, KREAL
       real(KREAL) ::  v1x,v1y,v1z,norm1
       real(KREAL) ::  v2x,v2y,v2z,norm2
       real(KREAL) ::  angle
     END FUNCTION ANGLE

     FUNCTION SinAngle(v1x,v1y,v1z,norm1,v2x,v2y,v2z,norm2)
        use Path_module, only :  Pi,KINT, KREAL
       real(KREAL) ::  v1x,v1y,v1z,norm1
       real(KREAL) ::  v2x,v2y,v2z,norm2
       real(KREAL) ::  SinAngle
     END FUNCTION SINANGLE


     FUNCTION angle_d(v1x,v1y,v1z,norm1,v2x,v2y,v2z,norm2,v3x,v3y,v3z,norm3)
        use Path_module, only :  Pi,KINT, KREAL
       real(KREAL) ::  v1x,v1y,v1z,norm1
       real(KREAL) ::  v2x,v2y,v2z,norm2
       real(KREAL) ::  v3x,v3y,v3z,norm3
       real(KREAL) ::  angle_d,ca,sa
     END FUNCTION ANGLE_D

  END INTERFACE

  DO I=1,NCart
     val_zmat(I,1)=x(ind_zmat(I,1))
     val_zmat(I,2)=y(ind_zmat(I,1))
     val_zmat(I,3)=z(ind_zmat(I,1))
  END DO

  SELECT CASE (Ncart)
     CASE (1)
        i=2
        n1=ind_zmat(i,1)
        n2=ind_zmat(i,2)

        CALL vecteur(n2,n1,x,y,z,vx1,vy1,vz1,norm1)
     !           write(*,11) n1,n2,norm1

        val_zmat(i,1)=norm1
        val_zmat(i,2)=0.0
        val_zmat(i,3)=0.0
     i=3
     n1=ind_zmat(i,1)
     n2=ind_zmat(i,2)
     n3=ind_zmat(i,3)

     CALL vecteur(n2,n1,x,y,z,vx1,vy1,vz1,norm1)

     CALL vecteur(n2,n3,x,y,z,vx2,vy2,vz2,norm2)
     val=angle(vx1,vy1,vz1,norm1,vx2,vy2,vz2,norm2)

     val_zmat(i,1)=norm1
     val_zmat(i,2)=val
     val_zmat(i,3)=0.0

     Ibeg=4
     CASE (2)

     i=3
     n1=ind_zmat(i,1)
     n2=ind_zmat(i,2)
     n3=ind_zmat(i,3)

     CALL vecteur(n2,n1,x,y,z,vx1,vy1,vz1,norm1)

     CALL vecteur(n2,n3,x,y,z,vx2,vy2,vz2,norm2)
     val=angle(vx1,vy1,vz1,norm1,vx2,vy2,vz2,norm2)

     val_zmat(i,1)=norm1
     val_zmat(i,2)=val
     val_zmat(i,3)=0.0
     Ibeg=4
  CASE DEFAULT
     Ibeg=Ncart+1
  END SELECT
  DO i=IBeg,nb
     !        write(*,*) 'Debut procedure Xyz_Zmat4'
     n1=ind_zmat(i,1)
     n2=ind_zmat(i,2)
     n3=ind_zmat(i,3)
     n4=ind_zmat(i,4)

     CALL vecteur(n2,n1,x,y,z,vx1,vy1,vz1,norm1)

     !        write(*,*) 'Debut procedure Xyz_Zmat42'
     CALL vecteur(n2,n3,x,y,z,vx2,vy2,vz2,norm2)
     val=angle(vx1,vy1,vz1,norm1, vx2,vy2,vz2,norm2)

     !        write(*,*) 'Debut procedure Xyz_Zmat43'
     CALL vecteur(n3,n4,x,y,z,vx3,vy3,vz3,norm3)
     CALL produit_vect(vx1,vy1,vz1,norm1,vx2,vy2,vz2,norm2,vx4,vy4,vz4,norm4)
     CALL produit_vect(vx3,vy3,vz3,norm3,vx2,vy2,vz2,norm2,vx5,vy5,vz5,norm5)
     val_d=angle_d(vx4,vy4,vz4,norm4, vx5,vy5,vz5,norm5,vx2,vy2,vz2,norm2)

     !               write(*,11) n1,n2,norm1,n3,val,n4,val_d
11   format (2(1x,i3),1x,f8.4,2(1x,i3,1x,f8.3))

     val_zmat(i,1)=norm1
     val_zmat(i,2)=val
     val_zmat(i,3)=val_d

  END DO
  RETURN
END SUBROUTINE ConvXyzMixed
